/*
 *	JCGץ륢ץꥱ(ɾ¸ѥץ) - Ͽޤ -
 *	Copyright (C) 2000 Personal Media Corporation
 */
#include	"dt.h"
#include	"prototype.h"

#define	PERIOD	2.5			/* 400[MHz]ʤΤ 2.5[ns]	*/

IMPORT	PNTs	map1[];
IMPORT	PNTs	map2[];
IMPORT	PNTs	map3[];
IMPORT	W	map1_num;
IMPORT	W	map2_num;
IMPORT	W	map3_num;

EXPORT	W	z_fact = 100;		/* Ψ[%]			*/
EXPORT	W	l_wid  = 1;		/* [dot]			*/
EXPORT	W	l_pat  = 1;		/* ѥֹ		*/
EXPORT	W	m_num  = 0;		/* Ͽֹ			*/

EXPORT	FLOAT	zf_float = 1.0;		/* Ψ(¿)			*/

EXPORT	PNT	view_pnt = {		/* ɽΰ濴ɸ		*/
			240, 240
		};
EXPORT	PNT	view_top = {		/* ɽΰκ		*/
			0, 0
		};
EXPORT	RECT	view_rect = {		/* ɽΰ			*/
			{0, 0, 480, 480}
		};

#define	MAPs_MAX	3		/* Ͽޤ			*/
LOCAL	VP	map_datas[MAPs_MAX] = {
			map1,
			map2,
			map3
		};

/*------------------------------------------------------------Clock count Get*/
LOCAL	SYSTIME	c_get(VOID)
{
	SYSTIME	time;
	unsigned long long int x;

	__asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));

	time = x * PERIOD;

	return time;
}

/*--------------------------------------------------------------Draw Map DATA*/
EXPORT	W	draw_map(VOID)
{
	W	l;
	W	er;
	W	r_chg;			/* Ψ˱ɽΰѰ	*/
	W	pt1, pt2;		/* Υԥå󥰤η	*/
	W	line_num = 0;
	PNTs	*map_data;
	PNTs	lin;
	SYSTIME	s_time;
	SYSTIME	e_time;

	er = 0;

	r_chg    = ((FLOAT)(100) / (FLOAT)(z_fact)) * 240;
	zf_float = (FLOAT)(z_fact) / (FLOAT)(100);

	view_rect.c.left   = view_pnt.x - r_chg;
	view_rect.c.top    = view_pnt.y - r_chg;
	view_rect.c.right  = view_pnt.x + r_chg;
	view_rect.c.bottom = view_pnt.y + r_chg;

	view_top.x = view_rect.c.left;
	view_top.y = view_rect.c.top;

	if ((m_num < 0) || (m_num >= MAPs_MAX)) goto EXIT;
	map_data = map_datas[m_num];
	er = gp_fil_rec(map_gid, map_rect, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec(map) : er = %d\n", er);
		goto EXIT;
	}
	switch (m_num) {
		case 0:
			line_num = map1_num;
			break;
		case 1:
			line_num = map2_num;
			break;
		case 2:
			line_num = map3_num;
			break;
	}

	printf("----------------/log start\n");
	printf("map number : %1d\n"         , m_num + 1             );
	printf("zoom factor : %3d    "      , z_fact                );
	printf("line width : %2d(dot)    "  , l_wid                 );
	printf("draw pattern : %1d\n"       , l_pat                 );
	printf("center point : (%4d, %4d)\n", view_pnt.x, view_pnt.y);
	s_time = c_get();
	printf("start time : %3.3f(ms)    ", (FLOAT)s_time / (FLOAT)1000000);

	for (l = 0; l < line_num; l++) {
		er = gp_pic_rec(map_data[l].s, view_rect, 0);
		if (er < E_OK) {
			printf("gp_pic_rec(s_pnt) : er = %d\n", er);
			break;
		}
		pt1 = er;
		er = gp_pic_rec(map_data[l].e, view_rect, 0);
		if (er < E_OK) {
			printf("gp_pic_rec(e_pnt) : er = %d\n", er);
			break;
		}
		pt2 = er;
		if ((pt1 == 1) || (pt2 == 1)) {
			lin.s.x = (map_data[l].s.x - view_top.x) * zf_float;
			lin.s.y = (map_data[l].s.y - view_top.y) * zf_float;
			lin.e.x = (map_data[l].e.x - view_top.x) * zf_float;
			lin.e.y = (map_data[l].e.y - view_top.y) * zf_float;
			er = gp_dra_lin(map_gid, lin.s, lin.e, l_wid, l_pat,
								G_STORE);
			if (er < E_OK) {
				printf("gp_dra_lin (map) : er = %d\n", er);
				break;
			}
		}
	}

	e_time = c_get();
	printf("end time : %3.3f(ms)    ", (FLOAT)e_time / (FLOAT)1000000);
	printf("total time : %3.2f(ms)\n", (FLOAT)(e_time - s_time) / (FLOAT)1000000);

EXIT:
	return er;
}
