/*
 *	JCGץ륢ץꥱ(ƥȥץ)
 *	Copyright (C) 2000 Personal Media Corporation
 */

/*
ƥ

	٥ȴϤǤ
	λˤ KC_NL Ϥޤ
*/

#include	"common.h"
#include	<tcode.h>
#include	<keycode.h>

#define	SET_SIZE	256

LOCAL	ID	tskid0 = -1;
LOCAL	PD_ATTR	pd_attr = {
			200, 200
		};
LOCAL	KEY_ATTR	key_attr = {
			200, 1000
		};
LOCAL   TC      key_tbl[SET_SIZE] = {		/* ͤƱ		*/
TNULL, TK_DICT, TK_1, TK_2, TK_3, TK_4, TK_5, TK_6, TK_7, TK_8,
TK_9, TK_0, TK_MINS, TK_EXOR, TK_BS, TK_TAB, TK_Q, TK_W, TK_E, TK_R,
TK_T, TK_Y, TK_U, TK_I, TK_O, TK_P, TK_ATMK, TK_LABR, TK_NL, TNULL,
TK_A, TK_S, TK_D, TK_F, TK_G, TK_H, TK_J, TK_K, TK_L, TK_SCLN, 
TK_COLN, TK_LABR, TK_NL, TK_RABR, TK_Z, TK_X, TK_C, TK_V, TK_B, TK_N,
TK_M, TK_CMMA, TK_PROD, TK_SLSH, TNULL, TNULL, TNULL, TK_KSP, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, 0x100, 0x101, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL,
TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, 0x103,
0x102, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL, TNULL
};

/*---------------------------------------------------------------Exit Process*/
EXPORT	VOID	ext_proc(VOID)
{

	exd_tsk();

}

/*-------------------------------------------------------------Test Procedure*/
LOCAL	W	tst_proc(VOID)
{
	W	er;
	EVENT	evt;

	er = ge_set_pda(&pd_attr);		/* PD°		*/
	printf("ge_set_pda (pd_attr = {%d, %d}) : er = %d\n", pd_attr.sense_x, pd_attr.sense_y, er);
	if (er < E_OK) goto EXIT;

	er = ge_set_kya(&key_attr);		/* KB°		*/
	printf("ge_set_kya (key_attr = {%d, %d}) : er = %d\n", key_attr.rep_delay, key_attr.rep_int, er);
	if (er < E_OK) goto EXIT;

	er = ge_set_ktb(SET_SIZE, key_tbl);	/* KB-tbl		*/
	printf("ge_set_ktb : er = %d\n", er);
	if (er < E_OK) goto EXIT;

	do {					/* EVT		*/
		er = ge_get_evt(&evt, TMO_FEVR, 1);
		printf("ge_get_evt : er = %d, type = 0x%x, pos = (%d, %d), key = 0x%x, stat = 0x%x\n", er, evt.type, evt.pos.x, evt.pos.y, evt.key, evt.stat);
	} while ((evt.key != KC_NL) && (er >= E_OK));

EXIT:
	return er;
}

/*--------------------------------------------------------Test Call Procedure*/
LOCAL	VOID	tst_call(VOID)
{
	W	er;

	er = gp_ini_env(NULL);
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		ext_proc();
	}
	dly_tsk(1000);
	er = ge_ini_evt(NULL);
	if (er < E_OK) {
		printf("ge_ini_evt : er = %d\n", er);
		ext_proc();
	}
	er = init_evtsvr(1);
	if (er < E_OK) {
		printf("init_evtsvr : er = %d\n", er);
		ext_proc();
	}

	tst_proc();

	exd_tsk();
}

/*-------------------------------------------------------------Main Procedure*/
EXPORT	ERR	main(Bool su, TC *arg)
{
	ERR	er;
	ID	tskid;
	T_CTSK	ctsk;

	if (su) {				/* ư		*/
		ctsk.exinf   = (VP)CH4toW('t', 's', '0', '4');
		ctsk.task    = tst_call;
		ctsk.itskpri = 120;
		ctsk.stksz   = 0x4000;
		ctsk.tskatr  = TA_HLNG | TA_RNG0;

		er = vcre_tsk(&ctsk);		/* 		*/
		if (er < E_OK) goto EXIT;
		tskid = (ID)er;
		er    = sta_tsk(tskid, 0);	/* εư		*/
		if (er < E_OK) {
			del_tsk(tskid);
			goto EXIT;
		}
		tskid0 = er;
		er = 0;
	} else {				/* λ		*/
		er = 0;
		init_evtsvr(0);
		ter_tsk(tskid0);		/* 񸻤β		*/
		del_tsk(tskid0);
	}

EXIT:
	return er;
}

/*----------------------------------------------------------------End of File*/
