/*
 *	JCGץ륢ץꥱ(ƥȥץ)
 *	Copyright (C) 2000 Personal Media Corporation
 */

/*
ƥ

	ʸϴϤǤ
*/

#include	"common.h"
#include	<tcode.h>
#include	<keycode.h>

LOCAL	ID	tskid0 = -1;

LOCAL	TC	str[] = (TC[]){
			TK_T, TK_E, TK_S, TK_T, TNULL
		};
LOCAL	PARTS	parts = {
			GC_TBPARTS, {{10, 10, 82, 34}}, 0, str
		};

/*---------------------------------------------------------------Exit Process*/
LOCAL	VOID	ext_proc(VOID)
{

	exd_tsk();

}

/*-------------------------------------------------------------Test Procedure*/
LOCAL	W	tst_proc(VOID)
{
	W	l;
	W	er;
	W	cid = -1;
	EVENT	evt;
	TC	strC[30];

	er = gt_cre_par(0, &parts);
	printf("gt_cre_par : er = %d\n", er);
	if (er < E_OK) goto EXIT;
	cid = er;

	er = gt_dsp_par(cid, 0);
	printf("gt_dsp_par (cid = %d) : er = %d\n", cid, er);
	if (er < E_OK) goto EXIT;

	do {
		er = ge_get_evt(&evt, TMO_FEVR, 1);
		if (er < E_OK) {
			printf("ge_get_evt : er = %d\n", er);
			break;
		}
		er = gt_act_par(cid, &evt);
		printf("gt_act_par (cid = %d) : er = %d\n", cid, er);
	} while ((er >= E_OK) && (evt.key != KC_NL));
	if (er < E_OK) goto EXIT;

	er = gt_get_par(cid, strC, 10);
	printf("gt_get_par (cid = %d) : er = %d\n", cid, er);
	for (l = 0; strC[l] != TNULL; l++) printf("0x%04x ", strC[l]);
	printf("\n");

	er = gt_del_par(cid);
	printf("gt_del_par (cid = %d) : er = %d\n", cid, er);
	cid = -1;

EXIT:
	if (cid >= 0) gt_del_par(cid);
	init_evtsvr(0);
	return er;
}

/*--------------------------------------------------------Test Call Procedure*/
LOCAL	VOID	tst_call(VOID)
{
	W	er;

	er = gp_ini_env(NULL);
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		ext_proc();
	}
	er = gc_ini_par(NULL);
	if (er < E_OK) {
		printf("gc_ini_par : er = %d\n", er);
	}
	er = ge_ini_evt(NULL);
	if (er < E_OK) {
		printf("ge_ini_evt : er = %d\n", er);
		ext_proc();
	}
	er = init_evtsvr(1);
	if (er < E_OK) {
		printf("init_evtsvr : er = %d\n", er);
		ext_proc();
	}

	er = gp_fil_rec(0, (RECT){{0, 0, 640, 480}}, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec : er = %d\n", er);
		ext_proc();
	}

	dly_tsk(1000);
	printf("\n");
	tst_proc();

	exd_tsk();
}

/*-------------------------------------------------------------Main Procedure*/
EXPORT	ERR	main(Bool su, TC *arg)
{
	ERR	er;
	ID	tskid;
	T_CTSK	ctsk;

	if (su) {				/* ư		*/
		ctsk.exinf   = (VP)CH4toW('t', 's', '0', '4');
		ctsk.task    = tst_call;
		ctsk.itskpri = 120;
		ctsk.stksz   = 0x4000;
		ctsk.tskatr  = TA_HLNG | TA_RNG0;

		er = vcre_tsk(&ctsk);		/* 		*/
		if (er < E_OK) goto EXIT;
		tskid = (ID)er;
		er    = sta_tsk(tskid, 0);	/* εư		*/
		if (er < E_OK) {
			del_tsk(tskid);
			goto EXIT;
		}
		tskid0 = er;
		er = 0;
	} else {				/* λ		*/
		er = 0;
		init_evtsvr(0);
		ter_tsk(tskid0);		/* 񸻤β		*/
		del_tsk(tskid0);
	}

EXIT:
	return er;
}

/*----------------------------------------------------------------End of File*/
