/*
 *	JCGץ륢ץꥱ(ɾ¸ѥץ) - ѡư -
 *	Copyright (C) 2000 Personal Media Corporation
 */
#include	"dt.h"
#include	"prototype.h"

#define	MAP1_PAR	0
#define	MAP2_PAR	1
#define	MAP3_PAR	2
#define	Z50_PAR		3
#define	Z100_PAR	4
#define	Z200_PAR	5
#define	Z400_PAR	6
#define	LBIG_PAR	7
#define	LSMA_PAR	8
#define	PPLS_PAR	9
#define	PMNS_PAR	10
#define	FIN_PAR		11

/*--------------------------------------------------Parts Operating Procedure*/
EXPORT	VOID	parts_ope(VOID)
{
	W	er;
	W	item;
	W	f_sign;
	W	z_factF = -1;
	W	l_widF  = -1;
	W	l_patF  = -1;
	W	m_numF  = -1;
#ifdef	MAP_DRAG
	PNT	p_pnt;
#endif	/* MAP_DRAG */
	Bool	map_press;
	EVENT	evt;

	er = draw_map();
	if (er < E_OK) goto EXIT;
	map_press = False;
	for (er = 0 ; er >= E_OK; ) {
		evt.type = GE_NULL;
		er = gp_act_scn(scn_wid, scn_wid, &evt, NULL, &item, TMO_FEVR);
		if (er < E_OK) break;
		if (er & GC_ACT) {
			f_sign = 0;
			switch (item) {
				case MAP1_PAR:
					m_num = 0;
					break;
				case MAP2_PAR:
					m_num = 1;
					break;
				case MAP3_PAR:
					m_num = 2;
					break;
				case Z50_PAR:
					z_fact = 50;
					break;
				case Z100_PAR:
					z_fact = 100;
					break;
				case Z200_PAR:
					z_fact = 200;
					break;
				case Z400_PAR:
					z_fact = 400;
					break;
				case LBIG_PAR:
					f_sign = 2;
				case LSMA_PAR:
					f_sign--;
					l_wid = l_wid + f_sign * W_STEP;
					if (l_wid < W_MIN) l_wid = W_MIN;
					if (l_wid > W_MAX) l_wid = W_MAX;
					break;
				case PPLS_PAR:
					f_sign = 2;
				case PMNS_PAR:
					f_sign--;
					l_pat = l_pat + f_sign * P_STEP;
						if (l_pat < P_MIN) l_pat=P_MIN;
						if (l_pat > P_MAX) l_pat=P_MAX;
					break;
				case FIN_PAR:
					printf("exit...\n");
					er = -1;
					goto EXIT;
			}
			if ((z_factF != z_fact) || (l_widF != l_wid) ||
			    (l_patF  != l_pat ) || (m_numF != m_num)) {
				er = draw_map();
				if (er < E_OK) break;
				z_factF = z_fact;
				l_widF  = l_wid;
				l_patF  = l_pat;
				m_numF  = m_num;
			}
		} else {
			switch (evt.type) {
				case GE_BUTDWN:
					er = gp_pic_rec(evt.pos, map_rect, 0);
					if (er < E_OK) {
						printf("gp_pic_rec : er = %d"
									, er);
						break;
					} else if (er == 1) {
						map_press = True;
#ifdef	MAP_DRAG
						p_pnt = evt.pos;
#endif	/* MAP_DRAG */
					}
					break;
				case GE_BUTUP:
					if (map_press) {
						map_press = False;
#ifndef	MAP_DRAG
						view_pnt.x = view_top.x
							+ evt.pos.x / zf_float;
						view_pnt.y = view_top.y
							+ evt.pos.y / zf_float;
						er = draw_map();
#endif	/* MAP_DRAG */
					}
					break;
#ifdef	MAP_DRAG
				default:
					if (map_press) {
						view_pnt.x += (p_pnt.x
							- evt.pos.x)/ zf_float;
						view_pnt.y += (p_pnt.y
							- evt.pos.y)/ zf_float;
						p_pnt = evt.pos;
						er = draw_map();
					}
#endif	/* MAP_DRAG */
			}
		}
	}

EXIT:
	ext_tsk();
}
