/*
 *	JCGץ륢ץꥱ(ɾ¸ѥץ) -  -
 *	Copyright (C) 2000 Personal Media Corporation
 */
#include	"rt.h"
#include	"prototype.h"

EXPORT	W	map_gid = -1;		/* ϿޤĶ		*/
EXPORT	W	scn_wid = -1;		/* ѡѥWID		*/

EXPORT	RECT	map_rect = {
			{0, 0, 480, 480}
		};

LOCAL	W	init_env(VOID);
LOCAL	W	init_scn(VOID);
LOCAL	W	init_map(VOID);

#define	SCN_PAR	10
LOCAL	TC	z50_str[]   = (TC[]){MC_STR, 0x2335, 0x2330, TNULL};
LOCAL	TC	z100_str[]  = (TC[]){MC_STR, 0x2331, 0x2330, 0x2330, TNULL};
LOCAL	TC	z200_str[]  = (TC[]){MC_STR, 0x2332, 0x2330, 0x2330, TNULL};
LOCAL	TC	z400_str[]  = (TC[]){MC_STR, 0x2334, 0x2330, 0x2330, TNULL};
LOCAL	TC	stop_str[]  = (TC[]){MC_STR, 0x2126, TNULL};
LOCAL	TC	up_str[]    = (TC[]){MC_STR, 0x222c, TNULL};
LOCAL	TC	down_str[]  = (TC[]){MC_STR, 0x222d, TNULL};
LOCAL	TC	left_str[]  = (TC[]){MC_STR, 0x222b, TNULL};
LOCAL	TC	right_str[] = (TC[]){MC_STR, 0x222a, TNULL};
LOCAL	TC	fin_str[]   = (TC[]){MC_STR, 0x3d2a, 0x4e3b, TNULL};

LOCAL	PARTS	scn_par[SCN_PAR] = {
			{GC_MSPARTS, {{500,  10, 560,  46}}, 0, z50_str  },
			{GC_MSPARTS, {{570,  10, 630,  46}}, 0, z100_str },
			{GC_MSPARTS, {{500,  56, 560,  92}}, 0, z200_str },
			{GC_MSPARTS, {{570,  56, 630,  92}}, 0, z400_str },
			{GC_MSPARTS, {{547, 280, 582, 315}}, 0, stop_str },
			{GC_MSPARTS, {{547, 233, 582, 268}}, 0, up_str   },
			{GC_MSPARTS, {{547, 328, 582, 363}}, 0, down_str },
			{GC_MSPARTS, {{500, 280, 535, 315}}, 0, left_str },
			{GC_MSPARTS, {{595, 280, 630, 315}}, 0, right_str},
			{GC_MSPARTS, {{500, 383, 630, 465}}, 0, fin_str  }
		};

/*------------------------------------------------Initialize Basic Enviromant*/
LOCAL	W	init_env(VOID)
{
	W	er;

	er = gp_ini_env(NULL);		/* ܴĶν		*/
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		goto EXIT;
	}
	er = gp_ini_pnl(NULL);
	if (er < E_OK) {
		printf("gp_ini_pnl : er = %d\n", er);
		goto EXIT;
	}
	er = gc_ini_par(NULL);
	if (er < E_OK) {
		printf("gc_ini_par : er = %d\n", er);
		goto EXIT;
	}
	er = ge_ini_evt(NULL);
	if (er < E_OK) {
		printf("ge_ini_evt : er = %d\n", er);
		goto EXIT;
	}
	er = init_evtsvr(1);
	if (er < E_OK) {
		printf("init_evtsvr : er = %d\n", er);
		goto EXIT;
	}

	er = gp_fil_rec(0, (RECT){{0, 0, 640, 480}}, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec : er = %d\n", er);
		goto EXIT;
	}

EXIT:
	return er;
}

/*-------------------------------------------------Initialize Scene Procedure*/
LOCAL	W	init_scn(VOID)
{
	W	er;

	er = gp_cre_scn(&scn_par[0], SCN_PAR);
	if (er < 0) {
		printf("gp_cre_scn : er = %d\n", er);
		goto EXIT;
	}
	scn_wid = er;
	er = gp_swi_scn(scn_wid);
	if (er < 0) {
		printf("gp_swi_scn : er = %d\n", er);
	}

EXIT:
	return er;
}

/*--------------------------------Initialize MAP Graphic Enviroment Procedure*/
LOCAL	W	init_map(VOID)
{
	W	er;
	VP	map_env  = NULL;	/* ϿޤĶ	*/
	PNT	gid_pnt  = {0, 0};

	er = gp_cre_env(map_env);	/* ϿޤĶν	*/
	if (er < E_OK) {
		printf("gp_cre_env : er = %d\n", er);
		goto EXIT;
	}
	map_gid = er;
	er = gp_set_off(map_gid, &gid_pnt);
	if (er < E_OK) {
		printf("gp_set_off : er = %d\n", er);
		goto EXIT;
	}
	er = gp_set_vis(map_gid, &map_rect);
	if (er < E_OK) {
		printf("gp_set_vis : er = %d\n", er);
		goto EXIT;
	}
	er = gp_fra_rec(0, (RECT){{-1, -1, 481, 481}}, 1, 1, G_STORE);
	if (er < E_OK) {
		printf("gp_fra_rec : er = %d\n", er);
		goto EXIT;
	}

EXIT:
	return er;
}

/*-------------------------------------------------------Initialize Procedure*/
EXPORT	W	init_proc(VOID)
{
	W	er;

	er = init_env();
	if (er < E_OK) goto EXIT;
	er = init_scn();
	if (er < E_OK) goto EXIT;
	er = init_map();

EXIT:
	return er;
}

