/*
 *	JCGץ륢ץꥱ(ɾ¸ѥץ) - ѡư -
 *	Copyright (C) 2000 Personal Media Corporation
 */
#include	"rt.h"
#include	"prototype.h"

#define	PERIOD	2.5			/* 400[MHz]ʤΤ 2.5[ns]	*/

#define	Z50_PAR		0
#define	Z100_PAR	1
#define	Z200_PAR	2
#define	Z400_PAR	3
#define	STOP_PAR	4
#define	UP_PAR		5
#define	DOWN_PAR	6
#define	LEFT_PAR	7
#define	RIGHT_PAR	8
#define	FIN_PAR		9

EXPORT	W	delta_x = 0;		/* ΰư			*/
EXPORT	W	delta_y = -10;		/* Ĥΰư			*/

/*------------------------------------------------------------Clock count Get*/
LOCAL	SYSTIME	c_get(VOID)
{
	SYSTIME	time;
	unsigned long long int x;

	__asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));

	time = x * PERIOD;

	return time;
}

/*--------------------------------------------------Parts Operating Procedure*/
EXPORT	VOID	parts_ope(VOID)
{
	W	er;
	W	item;
	EVENT	evt;
	SYSTIME	s_time;
	SYSTIME	e_time;

	er = draw_map();
	if (er < E_OK) goto EXIT;
	for (er = 0 ; er >= E_OK; ) {
		evt.type = GE_NULL;
		er = gp_act_scn(scn_wid, scn_wid, &evt, NULL, &item, TMO_FEVR);
		if (er < E_OK) break;
		if ((er & GC_ACT) == 0) continue;

		printf("----------------/log start\n");
		printf("zoom factor : %3d    "      , z_fact                );
		printf("draw pattern : %1d    "     , l_pat                 );
		printf("parts ID : %1d\n"           , item                  ); 
		printf("center point : (%4d, %4d)\n", view_pnt.x, view_pnt.y);
		s_time = c_get();
		printf("start time : %3.3f(ms)    ", (FLOAT)s_time / (FLOAT)1000000);

		switch (item) {
			case Z50_PAR:
				z_fact = 50;
				break;
			case Z100_PAR:
				z_fact = 100;
				break;
			case Z200_PAR:
				z_fact = 200;
				break;
			case Z400_PAR:
				z_fact = 400;
				break;
			case STOP_PAR:
				delta_x = 0;
				delta_y = 0;
				break;
			case UP_PAR:
				delta_x = 0;
				delta_y = -10 * zf_float;
				break;
			case DOWN_PAR:
				delta_x = 0;
				delta_y = 10 * zf_float;
				break;
			case LEFT_PAR:
				delta_x = -10 * zf_float;
				delta_y = 0;
				break;
			case RIGHT_PAR:
				delta_x = 10 * zf_float;
				delta_y = 0;
				break;
			case FIN_PAR:
				printf("exit...\n");
				er = -1;
				goto EXIT;
		}
		e_time = c_get();
		printf("end time : %3.3f(ms)    ", (FLOAT)e_time / (FLOAT)1000000);
		printf("total time : %3.2f(ms)\n", (FLOAT)(e_time - s_time) / (FLOAT)1000000);
	}

EXIT:
	fin_proc();
	ext_tsk();
}
