/*
 *	JCGץ륢ץꥱ(ƥȥץ)
 *	Copyright (C) 2000 Personal Media Corporation
 */

/*
ƥ

	GUIϢץηǤ
	ꥵ޷Ԥ碌ƤߤƤޤ
*/

#include	"common.h"
#include	<tcode.h>
#include	<keycode.h>
#include	<bmath.h>

#define	VLP_HZOOM	0
#define	VLP_VZOOM	1
#define	MSP_EXIT	2
#define	MSP_DRAW	3
#define	TBP_ALPHA	4
#define	TBP_BETA	5
#define	TXT_ALPHA	6
#define	TXT_BETA	7

#define	CID_HZOOM	0
#define	CID_VZOOM	1
#define	CID_EXIT	2
#define	CID_DRAW	3
#define	CID_ALPHA	4
#define	CID_BETA	5

LOCAL	ID	tskid0 = -1;

LOCAL	PNT	a_pos = {564, 11};
LOCAL	PNT	b_pos = {564, 43};
LOCAL	RECT	grect = {{0, 0, 464, 464}};
LOCAL	TC	scn_dat[] = {
			GD_SCENE,
			GC_VLPARTS | GC_HALIGN, 0, 464, 464, 480, 100,
			2,
			10, 400,

			GD_NEXT,
			GC_VLPARTS, 464, 0, 480, 464, 100,
			2,
			10, 400,

			GD_NEXT,
			GC_MSPARTS, 485, 436, 557, 470, 0,
			4,
			MC_STR, 0x3d2a, 0x4e3b, TNULL,

			GD_NEXT,
			GC_MSPARTS | GC_EMPHAS, 563, 436, 635, 470, 0,
			4,
			MC_STR, 0x4941, 0x3268, TNULL,

			GD_NEXT,
			GC_TBPARTS, 563, 10, 635, 34, 1,
			2,
			0x2332, TNULL,

			GD_NEXT,
			GC_TBPARTS, 563, 42, 635, 66, 1,
			2,
			0x2333, TNULL,

			GD_NEXT,
			GC_TEXT, 524, 14, 0, 0, 1,
			3,
			0x2641, 0x2127, TNULL,

			GD_NEXT,
			GC_TEXT, 524, 46, 0, 0, 1,
			3,
			0x2642, 0x2127, TNULL,
			GD_END
		};

/*---------------------------------------------------------------Exit Process*/
LOCAL	VOID	ext_proc(VOID)
{

	exd_tsk();

}

/*--------------------------------------------------------Draw Main Procedure*/
LOCAL	W	draw_main(W gid, W hzoom, W vzoom)
{
	W	l;
	W	er;
	W	alpha;
	W	beta;
	PNT	pos1;
	FLOAT	theta;
	TC	strC[20];
	PNT	pos2 = {
			240, 240
		};

	er = gt_get_par(TBP_ALPHA, strC, 20);
	printf("gt_get_par (cid = 4) : er = %d\n", er);
	if (er < E_OK) goto EXIT;
	alpha = tc_atol(strC);
	if (alpha == 0) alpha = 1;

	er = gt_get_par(TBP_BETA, strC, 20);
	printf("gt_get_par (cid = 5) : er = %d\n", er);
	if (er < E_OK) goto EXIT;
	beta = tc_atol(strC);
	if (beta == 0) alpha = 1;

	er = gp_fil_rec(gid, grect, 0, G_STORE);
	printf("gp_fil_rec (gid = %d, r = {%d, %d, %d, %d}) : er = %d\n", gid, grect.c.left, grect.c.top, grect.c.right, grect.c.bottom, er);
	if (er < E_OK) goto EXIT;

	for (l = 0, er = 0; l <= 360 && er >= E_OK; l++) {
		theta = ((FLOAT)l / (FLOAT)180) * PI;
		pos1.x = 240 + hzoom * sin (alpha * theta);
		pos1.y = 240 + vzoom * sin (beta  * theta);
		er = gp_dra_lin(gid, pos1, pos2, 1, 1, G_STORE);
		pos2 = pos1;
		printf("gp_dra_lin (gid = %d, pos1 = (%d, %d), pos = (%d, %d) : er = %d\n", gid, pos1.x, pos1.y, pos2.x, pos2.y, er);
	}

EXIT:
	return er;
}

/*-------------------------------------------------------------Test Procedure*/
LOCAL	W	tst_proc(VOID)
{
	W	er;
	W	item;
	Bool	e_flg;
	EVENT	evt;
	W	gid   = -1;
	W	wid   = -1;
	W	hzoom = 100;
	W	vzoom = 100;
	Bool	a_flg = True;

	er = gd_reg_dat(scn_dat, &wid, 1);
	printf("gp_reg_dat : er = %d\n", er);
	if (er < E_OK) goto EXIT;

	er = gp_swi_scn(wid);
	printf("gp_swi_scn (wid = %d) : er = %d\n", wid, er);
	if (er < E_OK) goto EXIT;

	er = gp_kps_scn(wid, &a_pos);
	printf("gp_kyp_scn (p = (%d, %d)) : er = %d\n", a_pos.x, a_pos.y, er);
	if (er < E_OK) goto EXIT;

	er = gt_dsp_par(TBP_BETA, GC_DISABLE);
	printf("gt_dsp_par (gid = 5, mode = 0x800) : er = %d\n", er);

	er = gp_cre_env(NULL);
	printf("gp_cre_env : er = %d\n", er);
	if (er < E_OK) goto EXIT;
	gid = er;

	er = gp_set_vis(gid, &grect);
	printf("gp_set_vis (gid = %d, r = {%d, %d, %d, %d}) : er = %d\n", gid, grect.c.left, grect.c.top, grect.c.right, grect.c.bottom, er);
	if (er < E_OK) goto EXIT;

	for (er = 0, e_flg = False; er >= E_OK && e_flg == False; ){
		evt.type = NULL;
		er = gp_act_scn(wid, wid, &evt, NULL, &item, TMO_FEVR);
#ifdef	EVT_MSG
		printf("gp_act_scn (item = %d) : er = 0x%x\n", item, er);
#endif	/* EVT_MSG */
		if (evt.type == GE_KEYUP) {
			switch (evt.key) {
				case KC_NL:
					er = draw_main(gid, hzoom, vzoom);
					break;
				case KC_TAB:
					if (a_flg) {
						er = gp_kps_scn(wid, &b_pos);
						printf("gp_kyp_scn(p = (%d, %d)) : er = %d\n", b_pos.x, b_pos.y, er);
						er = gt_dsp_par(TBP_ALPHA, GC_DISABLE);
						printf("gt_dsp_par (gid = 4, mode = 0x800) : er = %d\n", er);
						er = gt_dsp_par(TBP_BETA, GC_ENABLE);
						printf("gt_dsp_par (gid = 5, mode = 0x8) : er = %d\n", er);
						a_flg = False;
					} else {
						er = gp_kps_scn(wid, &a_pos);
						printf("gp_kyp_scn(p = (%d, %d)) : er = %d\n", a_pos.x, a_pos.y, er);
						er = gt_dsp_par(TBP_ALPHA, GC_ENABLE);
						printf("gt_dsp_par (gid = 4, mode = 0x8) : er = %d\n", er);
						er = gt_dsp_par(TBP_BETA, GC_DISABLE);
						printf("gt_dsp_par (gid = 5, mode = 0x800) : er = %d\n", er);
						a_flg = True;
					}
			}
			continue;
		}
		if ((er < E_OK) || (!(er & GC_ACT))) continue;
		switch (item) {
			case VLP_HZOOM:
				er = gc_get_par(VLP_HZOOM, NULL, 0);
				printf("gc_get_par (cid = 0) : er = %d\n", er);
				if (er >= E_OK) {
					hzoom = er;
					er = draw_main(gid, hzoom, vzoom);
				}
				break;
			case VLP_VZOOM:
				er = gc_get_par(VLP_VZOOM, NULL, 0);
				printf("gc_get_par (cid = 1) : er = %d\n", er);
				if (er >= E_OK) {
					vzoom = er;
					er = draw_main(gid, hzoom, vzoom);
				}
				break;
			case MSP_EXIT:
				e_flg = True;
				break;
			case MSP_DRAW:
				er = draw_main(gid, hzoom, vzoom);
				break;
			case TBP_ALPHA:
				break;
			case TBP_BETA:
				break;
		}
	}

EXIT:
	if (wid >= E_OK) {
		er = gp_del_scn(wid);
		printf("gp_del_scn (wid = %d) : er = %d\n", wid, er);
	}
	if (gid >= E_OK) {
		er = gp_del_env(gid);
		printf("gp_del_env (gid = %d) : er = %d\n", gid, er);
	}
	init_evtsvr(0);
	return er;
}

/*--------------------------------------------------------Test Call Procedure*/
LOCAL	VOID	tst_call(VOID)
{
	W	er;

	er = gp_ini_env(NULL);
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		ext_proc();
	}
	er = gp_ini_pnl(NULL);
	if (er < E_OK) {
		printf("gp_ini_pnl : er = %d\n", er);
		ext_proc();
	}
	er = gc_ini_par(NULL);
	if (er < E_OK) {
		printf("gc_ini_par : er = %d\n", er);
		ext_proc();
	}
	er = ge_ini_evt(NULL);
	if (er < E_OK) {
		printf("ge_ini_evt : er = %d\n", er);
		ext_proc();
	}
	er = init_evtsvr(1);
	if (er < E_OK) {
		printf("init_evtsvr : er = %d\n", er);
		ext_proc();
	}

	er = gp_fil_rec(0, (RECT){{0, 0, 640, 480}}, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec : er = %d\n", er);
		ext_proc();
	}

	dly_tsk(1000);
	printf("\n");
	tst_proc();

	exd_tsk();
}

/*-------------------------------------------------------------Main Procedure*/
EXPORT	ERR	main(Bool su, TC *arg)
{
	ERR	er;
	ID	tskid;
	T_CTSK	ctsk;

	if (su) {				/* ư		*/
		ctsk.exinf   = (VP)CH4toW('t', 's', '0', '4');
		ctsk.task    = tst_call;
		ctsk.itskpri = 120;
		ctsk.stksz   = 0x4000;
		ctsk.tskatr  = TA_HLNG | TA_RNG0;

		er = vcre_tsk(&ctsk);		/* 		*/
		if (er < E_OK) goto EXIT;
		tskid = (ID)er;
		er    = sta_tsk(tskid, 0);	/* εư		*/
		if (er < E_OK) {
			del_tsk(tskid);
			goto EXIT;
		}
		tskid0 = er;
		er = 0;
	} else {				/* λ		*/
		er = 0;
		init_evtsvr(0);
		ter_tsk(tskid0);		/* 񸻤β		*/
		del_tsk(tskid0);
	}

EXIT:
	return er;
}

/*----------------------------------------------------------------End of File*/
