/*
 *	JCGץ륢ץꥱ(ƥȥץ)
 *	Copyright (C) 2000 Personal Media Corporation
 */

/*
ƥȤ

	ѥͥΥѥͥϢΥƥȤǤ
*/

#include	"common.h"
#include	<tcode.h>

typedef	struct {
	PARTS	par[5];
	W	cnt;
} PARTS_ARRAY;

typedef	struct {
	RECT		crct;
	PARTS_ARRAY	cpar;
	PARTS_ARRAY	spar;
	RECT		srct;
} PRM_TBL;

LOCAL	ID	tskid0 = -1;
LOCAL	TC	par1[] = {
			MC_STR, TK_T, TK_E, TK_S, TK_T, TNULL
		};
LOCAL	TC	par2[] = {
			MC_STR, TK_A, TK_B, TK_C, TNULL
		};
LOCAL	TC	par3[] = {
			MC_STR, TK_A, MC_STR, TK_B, MC_STR, TK_C, TNULL
		};
LOCAL	TC	str1[] = {
			MC_STR, TK_T, TK_E, TK_S, TK_T, TNULL
		};
LOCAL	TC	str2[] = {
			MC_STR, TK_A, TNULL
		};
LOCAL	TC	str3[] = {
			MC_STR, TK_A, TK_B, MC_STR, TK_C, TK_D, TNULL
		};
LOCAL	TC	str4[] = {
			MC_STR, TK_T, MC_STR, TK_E, MC_STR, TK_S,
			MC_STR, TK_T, TNULL
		};
LOCAL	PRM_TBL	parm_tbl[] = {
			{
				{{  0,   0, 200, 200}},
				{{
				 {GC_MSPARTS, {{10, 10, 82, 34}}, 0, par1}
				}, 1},
				{{
				 {GC_MSPARTS, {{100, 50, 182, 84}}, 0, str2}
				}, 0},
				{{10, 10, 60, 60}}
			},
			{
				{{ 10,  20,  400,  300}},
				{{
				 {GC_MSPARTS, {{ 10, 10,  82,  34}}, 0, par1},
				 {GC_ASPARTS, {{ 50, 50, 132,  84}}, 0, par2},
				 {GC_WSPARTS, {{100, 20, 150, 100}}, 0, par3}
				}, 3},
				{{
				 {GC_ASPARTS, {{ 10, 10, 102, 34}}, 0, str1}
				}, 0},
				{{90, 80, 190, 180}}
			},
			{
				{{-10, -10,  250,  250}},
				{{
				 {GC_MSPARTS, {{ 10, 10,  82,  34}}, 0, par1},
				 {GC_ASPARTS, {{ 50, 50, 132,  84}}, 0, par2},
				 {GC_WSPARTS, {{100, 20, 150, 100}}, 0, par3}
				}, 2},
				{{
				 {GC_WSPARTS, {{130, 10, 190, 54}}, 0, str3}
				}, 0},
				{{ 50, 50, 100, 100}}
			},
			{
				{{ 370,  260,  550,  430}},
				{{
				 {GC_MSPARTS, {{ 10, 10,  82,  34}}, 0, par1},
				 {GC_ASPARTS, {{ 50, 50, 132,  84}}, 0, par2},
				}, 1},
				{{
				 {GC_SSPARTS, {{ 10,  5,  66, 95}}, 1, str4}
				}, 0},
				{{400, 300, 500, 400}}
			}
		};

/*---------------------------------------------------------------Exit Process*/
EXPORT	VOID	ext_proc(VOID)
{

	exd_tsk();

}

/*-------------------------------------------------------------Test Procedure*/
LOCAL	W	tst_proc(PRM_TBL *prm)
{
	W	er;
	W	wid;

	printf("--------/\n");
						/* 			*/
	er = gp_cre_pnl(&prm->crct, &prm->cpar.par[0], prm->cpar.cnt);
	printf("gp_cre_pnl (r = {%d, %d, %d, %d}, cnt = %d) : er = %d\n", prm->crct.c.left, prm->crct.c.top, prm->crct.c.right, prm->crct.c.bottom , prm->cpar.cnt, er);
	if (er < E_OK) goto EXIT;
	wid = er;

						/* ɽ			*/
	er = gp_app_pnl(wid);
	printf("gp_app_pnl (wid = %d) : er = %d\n", wid, er);
	if (er < E_OK) goto EXIT;

	dly_tsk(2000);
						/* (ѡ)		*/
	er = gp_set_pnl(wid, prm->spar.cnt, &prm->spar.par[0]);
	printf("gp_set_pnl (wid = %d) : er = %d\n", wid, er);
	if (er < E_OK) goto EXIT;

	dly_tsk(2000);
						/* (ɽĹ)	*/
	er = gp_vis_pnl(wid, &prm->srct);
	printf("gp_vis_pnl (wid = %d, r = {%d, %d, %d, %d}) : er = %d\n", wid, prm->srct.c.left, prm->srct.c.top, prm->srct.c.right, prm->srct.c.bottom, er);
	gp_dra_lin(wid, (PNT){0, 0}, (PNT){prm->crct.c.right, prm->crct.c.bottom}, 1, 1, G_STORE);

EXIT:
	return er;
}

/*--------------------------------------------------------Test Call Procedure*/
LOCAL	VOID	tst_call(VOID)
{
	W	l;
	W	er;
	PRM_TBL	*prm = NULL;

	er = gp_ini_env(NULL);
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		ext_proc();
	}
	dly_tsk(1000);
	er = gp_ini_pnl(NULL);
	if (er < E_OK) {
		printf("gp_ini_pnl : er = %d\n", er);
		ext_proc();
	}
	dly_tsk(1000);
	er = gc_ini_par(NULL);
	if (er < E_OK) {
		printf("gc_ini_par : er = %d\n", er);
		ext_proc();
	}
	gp_fil_rec(0, (RECT){{0, 0, 640, 480}}, 0, G_STORE);

	for (l = 0; l < 4; l++) {
		dly_tsk(2000);
		prm = &parm_tbl[l];
		er = tst_proc(prm);
		if (er < E_OK) break;
	}

	exd_tsk();
}

/*-------------------------------------------------------------Main Procedure*/
EXPORT	ERR	main(Bool su, TC *arg)
{
	ERR	er;
	ID	tskid;
	T_CTSK	ctsk;

	if (su) {				/* ư		*/
		ctsk.exinf   = (VP)CH4toW('t', 's', '0', '4');
		ctsk.task    = tst_call;
		ctsk.itskpri = 120;
		ctsk.stksz   = 0x4000;
		ctsk.tskatr  = TA_HLNG | TA_RNG0;

		er = vcre_tsk(&ctsk);		/* 		*/
		if (er < E_OK) goto EXIT;
		tskid = (ID)er;
		er    = sta_tsk(tskid, 0);	/* εư		*/
		if (er < E_OK) {
			del_tsk(tskid);
			goto EXIT;
		}
		tskid0 = er;
		er = 0;
	} else {				/* λ		*/
		er = 0;
		ter_tsk(tskid0);		/* 񸻤β		*/
		del_tsk(tskid0);
	}

EXIT:
	return er;
}

/*----------------------------------------------------------------End of File*/
