/*
 *	JCGץ륢ץꥱ(ƥȥץ)
 *	Copyright (C) 2000 Personal Media Corporation
 */

/*
ƥ

	ѥͥϤǤ
*/

#include	"common.h"
#include	<tcode.h>
#include	<keycode.h>

#define	TEXT1		-1
#define	TEXT2		-1
#define	VLP_WIDTH	2
#define	WSP_PATTERN	3
#define	SSP_TYPE	4
#define	MSP_EXIT	5
#define	MSP_DRAW	6

#define	L_LIN		1
#define	L_REC		2
#define	L_RRC		3
#define	L_OVL		4

LOCAL	ID	tskid0 = -1;

LOCAL	TC	str1[] = (TC[]){MC_STR, 0x2551, 0x253f, 0x213c, 0x2573, 0x2331,
				MC_STR, 0x2551, 0x253f, 0x213c, 0x2573, 0x2332,
				TNULL};
LOCAL	TC	str2[] = (TC[]){0x3a59, TNULL};
LOCAL	TC	str3[] = (TC[]){0x4240, TNULL};
LOCAL	TC	str4[] = (TC[]){MC_STR, 0x443e, 0x407e,
				MC_STR, 0x4439, 0x4a7d, 0x3741,
				MC_STR, 0x3351, 0x345d, 0x4439, 0x4a7d, 0x3741,
				MC_STR, 0x315f, 0x213f, 0x424a, 0x315f,
				TNULL};
LOCAL	TC	str5[] = (TC[]){MC_STR, 0x4941, 0x3268, TNULL};
LOCAL	TC	str6[] = (TC[]){MC_STR, 0x3d2a, 0x4e3b, TNULL};
LOCAL	TC	vol[]  = (TC[]){1, 20};

LOCAL	RECT	pnl_rect = {
			{10, 10, 263, 129}
		};
LOCAL	PARTS	pnl_par[] = {
			{GC_TEXT,    {{ 10, 10,   0,   0}}, 1, str2},
			{GC_TEXT,    {{227, 10,   0,   0}}, 1, str3},
			{GC_VLPARTS | GC_HALIGN, {{ 26, 10, 226, 26}}, 1, vol},
			{GC_WSPARTS, {{ 10, 30, 116,  72}}, 1, str1},
			{GC_SSPARTS, {{123, 30, 243,  72}}, 1, str4},
			{GC_MSPARTS, {{ 10, 85,  82, 109}}, 0, str6},
			{GC_MSPARTS | GC_EMPHAS, {{171, 85, 243, 109}},0, str5}
		};

LOCAL	PNT	pnt1 = {
			300, 300
		};
LOCAL	PNT	pnt2 = {
			500, 400
		};
LOCAL	RECT	rct = {
			{300, 300, 500, 400}
		};

/*---------------------------------------------------------------Exit Process*/
LOCAL	VOID	ext_proc(VOID)
{

	exd_tsk();

}

/*--------------------------------------------------------Draw Main Procedure*/
LOCAL	W	draw_main(W l_wid, W l_pat, W l_typ)
{
	W	er;

	er = gp_fil_rec(0, rct, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec(erase) : er = %d\n", er);
		goto EXIT;
	}
	switch (l_typ) {
		case L_LIN:
			er = gp_dra_lin(0, pnt1, pnt2, l_wid, l_pat, G_STORE);
			printf("gp_dra_lin (l_wid = %2d, l_pat = %d) : er = %d\n", l_wid, l_pat, er);
			break;
		case L_REC:
			er = gp_fra_rec(0, rct, l_wid, l_pat, G_STORE);
			printf("gp_fra_rec (l_wid = %2d, l_pat = %d) : er = %d\n", l_wid, l_pat, er);
			break;
		case L_RRC:
			er = gp_fra_rrc(0, 20, 20, rct, l_wid, l_pat, G_STORE);
			printf("gp_fra_rrc (l_wid = %2d, l_pat = %d) : er = %d\n", l_wid, l_pat, er);
			break;
		case L_OVL:
			er = gp_fra_ovl(0, rct, l_wid, l_pat, G_STORE);
			printf("gp_fra_ovl (l_wid = %2d, l_pat = %d) : er = %d\n", l_wid, l_pat, er);
			break;
	}

EXIT:
	return er;
}

/*-------------------------------------------------------------Test Procedure*/
LOCAL	W	tst_proc(VOID)
{
	W	er;
	W	item;
	W	wid = -1;
	W	l_wid = 1;
	W	l_pat = 1;
	W	l_typ = 1;
	Bool	e_flg;
	EVENT	evt;

	er = gp_cre_pnl(&pnl_rect, pnl_par, 7);
	printf("gp_cre_pnl : er = %d\n", er);
	if (er < E_OK) goto EXIT;
	wid = er;
	er = gp_app_pnl(wid);
	printf("gp_app_pnl (wid = %d) : er = %d\n", wid, er);
	if (er < E_OK) goto EXIT;

	for (er = 0, e_flg = False; er >= E_OK && e_flg == False; ) {
		evt.type = NULL;
		er = gp_act_pnl(wid, wid, &evt, NULL, &item, TMO_FEVR);
		printf("gp_act_pnl (wid = %d, item = %d) : er = %d\n", wid, item, er);
		if (er < E_OK) continue;
		if (evt.key  == KC_NL   ) er = draw_main(l_wid, l_pat, l_typ);
		if (evt.type != GE_BUTUP) continue;
		switch (item) {
			case VLP_WIDTH:
				l_wid = gc_get_par(VLP_WIDTH - 2, NULL, 0);
				if (l_wid < E_OK) {
					printf("VLP_WIDTH : er = %d\n", er);
					er = l_wid;
				}
				break;
			case WSP_PATTERN:
				l_pat = gc_get_par(WSP_PATTERN - 2, NULL, 0);
				if (l_pat < E_OK) {
					printf("WSP_PATTRN : er = %d\n", er);
					er = l_pat;
				}
				break;
			case SSP_TYPE:
				l_typ = gc_get_par(SSP_TYPE - 2, NULL, 0);
				if (l_typ < E_OK) {
					printf("SSP_TYPE : er = %d\n", er);
					er = l_typ;
				}
				break;
			case MSP_EXIT:
				e_flg = True;
				break;
			case MSP_DRAW:
				er = draw_main(l_wid, l_pat, l_typ);
				break;
		}
	}

EXIT:
	if (wid >= 0) gp_del_pnl(wid);
	init_evtsvr(0);
	return er;
}

/*--------------------------------------------------------Test Call Procedure*/
LOCAL	VOID	tst_call(VOID)
{
	W	er;

	er = gp_ini_env(NULL);
	if (er < E_OK) {
		printf("gp_ini_env : er = %d\n", er);
		ext_proc();
	}
	er = gp_ini_pnl(NULL);
	if (er < E_OK) {
		printf("gp_ini_pnl : er = %d\n", er);
	}
	er = gc_ini_par(NULL);
	if (er < E_OK) {
		printf("gc_ini_par : er = %d\n", er);
	}
	er = ge_ini_evt(NULL);
	if (er < E_OK) {
		printf("ge_ini_evt : er = %d\n", er);
		ext_proc();
	}
	er = init_evtsvr(1);
	if (er < E_OK) {
		printf("init_evtsvr : er = %d\n", er);
		ext_proc();
	}

	er = gp_fil_rec(0, (RECT){{0, 0, 640, 480}}, 0, G_STORE);
	if (er < E_OK) {
		printf("gp_fil_rec : er = %d\n", er);
		ext_proc();
	}

	dly_tsk(1000);
	printf("\n");
	tst_proc();

	exd_tsk();
}

/*-------------------------------------------------------------Main Procedure*/
EXPORT	ERR	main(Bool su, TC *arg)
{
	ERR	er;
	ID	tskid;
	T_CTSK	ctsk;

	if (su) {				/* ư		*/
		ctsk.exinf   = (VP)CH4toW('t', 's', '0', '4');
		ctsk.task    = tst_call;
		ctsk.itskpri = 120;
		ctsk.stksz   = 0x4000;
		ctsk.tskatr  = TA_HLNG | TA_RNG0;

		er = vcre_tsk(&ctsk);		/* 		*/
		if (er < E_OK) goto EXIT;
		tskid = (ID)er;
		er    = sta_tsk(tskid, 0);	/* εư		*/
		if (er < E_OK) {
			del_tsk(tskid);
			goto EXIT;
		}
		tskid0 = er;
		er = 0;
	} else {				/* λ		*/
		er = 0;
		init_evtsvr(0);
		ter_tsk(tskid0);		/* 񸻤β		*/
		del_tsk(tskid0);
	}

EXIT:
	return er;
}

/*----------------------------------------------------------------End of File*/
